% params
T = 1.0;
rate = 50.0;

% uniform
ls = 0.0001;
uspikes = [];
while (ls < T)
    uspikes = [uspikes ls];
    ls = ls + 1.0/rate;
end

subplot(1, 2, 1);
LineFormatVert.LineWidth = 0.35;
plotSpikeRaster({uspikes}, ...
                'PlotType', 'vertline', ...
                'LineFormat', LineFormatVert, ...
                'VertSpikePosition', -0.5, ...
                'TimePerBin', 0.001, ...
                'VertSpikeHeight', 0.7);
xlabel('time (s)');
xlim([0 T]);


% poisson
pspikes = []
t = 0.0001;
dt = 0.001;
while (t < T)
    if (rand < rate*dt)
        pspikes = [pspikes t];
    end
    t = t + dt;
end

subplot(1, 2, 2);
LineFormatVert.LineWidth = 0.35;
plotSpikeRaster({pspikes}, ...
                'PlotType', 'vertline', ...
                'LineFormat', LineFormatVert, ...
                'VertSpikePosition', -0.5, ...
                'TimePerBin', 0.001, ...
                'VertSpikeHeight', 0.7);
xlabel('time (s)');
xlim([0 T]);