import nest

pop_size = 20

# inputs
pop1 = nest.Create('poisson_generator', pop_size)
pop2 = nest.Create('poisson_generator', pop_size)

# P
pop3 = nest.Create('iaf_neuron', pop_size)

# I
pop4 = nest.Create('iaf_neuron', pop_size)

# output
pop5 = nest.Create('iaf_neuron', pop_size)

# spikes recording
sd_pop5 = nest.Create('spike_detector', 1)
sd_all = nest.Create('spike_detector', 1)

# connections
nest.Connect(pop1, pop3, 'all_to_all', {'weight':  10.0 * 100.0 / pop_size, 'delay': 0.1})
nest.Connect(pop2, pop3, 'all_to_all', {'weight': -10.0 * 100.0 / pop_size, 'delay': 0.1})

rule = {'rule': 'pairwise_bernoulli', 'p': 0.8}
nest.Connect(pop3, pop5, rule, {'weight': 10.0 * 100.0 / pop_size, 'delay': 0.1})
nest.Connect(pop3, pop4, rule, {'weight': 18.0 * 100.0 / pop_size, 'delay': 0.1})
nest.Connect(pop4, pop4, rule, {'weight': 19.0 * 100.0 / pop_size, 'delay': 0.1})
nest.Connect(pop4, pop5, rule, {'weight': 3.81 * 100.0 / pop_size, 'delay': 0.1})

nest.Connect(pop5, sd_pop5)
nest.Connect(pop1, sd_all)
nest.Connect(pop2, sd_all)
nest.Connect(pop3, sd_all)
nest.Connect(pop4, sd_all)
nest.Connect(pop5, sd_all)


populations = {
	'pop1': pop1,
	'pop2': pop2,
	'sd_pop5': sd_pop5,
	'sd_all': sd_all
}
